\documentclass[a4paper,12pt,oneside]{scrreprt}
\usepackage[latin1]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{ae,aecompl}
\usepackage[english]{babel}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{wrapfig}
\usepackage{ulem}
\usepackage{cancel}
\usepackage{float}
\usepackage{color}
\usepackage{titlesec}
\usepackage{geometry}
\usepackage{listings}
\geometry{verbose,a4paper,tmargin=25mm,bmargin=25mm,lmargin=15mm,rmargin=25mm}
\titlelabel{\thetitle.\quad}
\usepackage{tabularx}
\usepackage{booktabs}
\usepackage{paralist}
\usepackage{textcomp}
\usepackage[official]{eurosym}

\usepackage{hyperref}
\hypersetup{
    colorlinks=true,
    linkcolor=blue,
    filecolor=magenta,      
    urlcolor=cyan,
}


\renewcommand{\rmdefault}{phv}
\renewcommand{\sfdefault}{phv}

\begin{document}
    \begin{tabular*}{\textwidth}{c @{\extracolsep{\fill}} cc}
        \begin{large}
            \textbf{Prof. Lichter}
        \end{large} &

        \begin{minipage}[H]{3.5cm}
            \centering
            \begin{large}
                OOSC
            \end{large} \\
            \begin{large}
                WS 2019/2020
            \end{large}
        \end{minipage} &

        \begin{minipage}[H]{4cm}
            \includegraphics[keepaspectratio,width=\textwidth,angle=0]{logoswc.png}
        \end{minipage} \\
        Andreas Steffens & & \\
        Konrad F\"ogen & &  \\
        & \begin{huge}
              \textbf{Submission 3}
        \end{huge}&  \\
        & oosc@swc.rwth-aachen.de &  \\
        & & \\
        % Hier drunter mÃ¼ssen die Daten noch angepasst werden
        Issued: 18.11.2019 &
        Submission: 02.12.2019 &
        Discussion: 12.12.2019 \\
    \end{tabular*}
    \newline \newline \newline
    \begin{center}
        Submitted by 07

        \begin{tabular}{ll}
            Radu-Andrei Coanda, 344664. \\
            Clemens Frohnhofer, 333800\\
            Silas G\"unther, 382506  \\
            Christoph Kr\"amer, 318424  \\
        \end{tabular}
        \newline
        \\
        https://git.rwth-aachen.de/radu.coanda/19ws-oosc
    \end{center}

    \setcounter{chapter}{3} % Aktuelles Assigment
    \section{Assignment: }
    \begin{enumerate}
        \item [a)]
        The given code snippet will not compile, because we have a static instance variable and a static method. Both of them access the generic type T from the class, which is not possible, because one would need to instantiate the class Singleton to define the generic type, but from a static context you cannot access instances.
        Therefore we need to change the signature of the method to:\\ \textit{public static <T> T getInstance()}\\
        \\ 
        For the instance variable we can change the type from T to Object, because primitive types are not allowed with generics, thus the Singleton will never be able to hold a primitive type and all other types are subtypes of type Object:\\
        \textit{private static Object instance}\\
        \\
        The we can remove the generic type from the class Singleton. \\
        In the next step we have to create a new instance, if the actual instance is null. As this is not possible with new = T(), we can use relection:\\
        \textit{instance = clazz.newInstance()}\\
        Possible exceptions are passed to the caller.
        Now we also have to pass the class of the desired instance to our method getInstance. Moreover in the end we have to cast the private variable instance to the desired type T. This results in the following Singleton class:
        \begin{lstlisting}[language=Java]
            public class Singleton{
                public static <T> T getInstance(Class<T> clazz) throws
                IllegalAccessException, InstantiationException {
                    if (instance == null)
                        instance = clazz.newInstance();
                        
                    return (T) instance;
                }
                private static Object instance = null;
            }
        \end{lstlisting}
        
        The problem here is, that the explicit downcast is not safe. Therefore we have to check first, if the instance is indeed of the desired type. If this is not the case, we throw an IllegalAccessException.
        \begin{lstlisting}[language=Java]
            public class Singleton{
                public static <T> T getInstance(Class<T> clazz) throws
                IllegalAccessException, InstantiationException {
                    if (instance == null)
                        instance = clazz.newInstance();
                    if(clazz.isInstance(instance)) {
                        return (T) instance;
                    }
                    throw new IllegalAccessException();
                }
                private static Object instance = null;
            }
        \end{lstlisting}
        
        \item[b)]
        The given code snippet will not compile, because the declared variables Zoo<Monkey> and Zoo<Animal> are different types. Thus we cannot simply assign an instance of Zoo<Monkey> to a variable of Zoo<Animal>. The reason is that we could otherwise fill our zoo of monkeys also with gorillas if they inherit from animal as well.\\
        \\
        To make a assignment possible, we have to change the generic type of the second zoo from 'Animal' to '? extends Animal'. This way we can assign all zoos of creatures inheriting from class animal.
        \item[c)]
        The given code snippet will not compile. First there is the generic type variable missing. Thus the compiler does not know, that T is a generic type and thus is searching for a class T. So to fix this the method signature has to start with \textit{public static <T> T max ...}. \\
        \\
        The second problem is, that the method uses unconstrained generics, but the binary operator '>' is not defined for arbitrary types. To fix this issue we can use the interface Comparable and again change the signature of the method to  \textit{public static <T extends Comparable> T max ...}. This way only comparable types can be passed to the method. In the next step we have to change the comparison itself to  \textit{x.compareTo(y) > 0 ...}. Now if x is greater than y the result of the compareTo-method will be 1, thus greater than 0 and thus the statement will result in true. This generates the same expected behavior as x>y.
        
        \item[d)]
        The difference between these methods is the allowed types we can pass as parameters to the methods. The method sumOfListVar1 expects a List of type Number or any sub type of Number wherea sumOfListVar2 expects exactly a List of type Number. Of course due to polymorphism it is possible in both cases to create a List of Number and then put subtypes of Number as actual elements into that List and pass that List to both methods.\\
        \begin{lstlisting}[language=Java]
            List<Number> numbers = new ArrayList<>();
            numbers.add(1); // adding integer
            numbers.add(1d); // adding double
            numbers.add(1f); // adding float
        
            double result1 = sumOfListVar1(numbers);
            double result2 = sumOfListVar2(numbers);
        \end{lstlisting}
        The advantages of the sumOfListVar1 is, that we can also pass Lists that hold elements that are a subtype of type Number. Thus we can restrict the elements we can add to the List and therefore have more control and are more flexible.
        \begin{lstlisting}[language=Java]
            List<Integer> numbers = new ArrayList<>();
            numbers.add(1); // adding integer
            numbers.add(2); // adding integer
            numbers.add(3); // adding integer
        
            // works totaly fine!
            double result1 = sumOfListVar1(numbers);
            
            // will not compile, because of not matching types
            double result2 = sumOfListVar2(numbers);
        \end{lstlisting}
    \end{enumerate}
    
    
    \section{Assignment: }
    \subsection*{(a)}
    We've identified the following design patterns. We note that, as to not to repeat ourselves, the \textbf{Open-Close
    Principle} is upheld in all the enumerated patterns, by simply using interfaces and abstract classes. 
    We also note that the library JHotDraw is not exclusive to only these patterns.

    \paragraph{Composite:}We observe this design pattern in the Figure and CompositeFigure classes. Using the Composite pattern, 
    a client can build a hierarchical tree structure of figures. This allows us afterwards to easily call methods specified 
    in the Figures interface class on all children by simply iterating and recursively calling the children's methods.\\

    \begin{itemize}
        \item \textit{Separation of Concerns:} The SoC is achived, by creating a boundary between the different
        specialized Figures, instead for example integrating them into one blob class, that has huge methods, where
        you differentiate between different types of figures.

        \item \textit{Single Responsability Principle:} Similarly to the previous argument, SRP is uphold by means of
        encapsulation. By creating a class for each type of figure, we let the implemented figures be responsible only
        for the features of said type.

        \item \textit{Composable:} This is the definition of the design pattern, more or less. This property is achived in
        the library, as it remains up to the client to mix-and-match different figures.

        \item \textit{Local:} Because the classes encapsulate only their own specialized behaviour (in the case of the Figure's 
        implementations), local changes is propagated only locally.
    
    \end{itemize}

    \paragraph{Decorator:}We observe this pattern with the Figure class and DecoratedFigure, with which we are able to 
    adorne a figure with another figure.\\
    
    \begin{itemize}
        \item \textit{Separation of Concerns:} The SoC is achieved, because the decorator class doesn't interfer with the
        decorated class. More over, the boundaries are clearly defined, via the interface defined by the decorator class. 

        \item \textit{Single Responsability Principle:} The decorator class is only concerned with wrapping around 
        the figure, therefore the SRP is again uphold.

        \item \textit{Composable: } Composability is furthered, as we can freely apply decorators to decorated figures, 
        as long as we would like. From another perspective, we can still freely use the decorated figures, like we previously 
        did, therefore the argument from the Composite design pattern concerning compsability still upholds.

        \item \textit{Local: } Locallity is uphold for the same reasons as for the Composite design pattern.
    \end{itemize}

    \paragraph{Observer}
    We observe this pattern in the Figure (Subject) and FigureListener (Observer) classes. State changes of figures can 
    be observed by other objects. Specifically CompositeFigure observes area invalidations and remove requests of its 
    child figures. \\

    \begin{itemize}
        \item \textit{Separation of Concerns}: As the subject is concerned with broadcasting his changes and the 
        observer is only concerned with reacting to said changes, we can reason, that there is SoC.

        \item \textit{Single Responsability Principle:} This might or might not be uphold. One might argue that the 
        subject is responsible for his state broadcasting, as well as his remaining features of being a Figure. We consider
        that the SRP is still uphold, and that the above argument is not applicable, as the through the rest of the features
        the state of the subject changes so that he has in the first place, changes to broadcast.

        \item \textit{Composable: } Composability is furthered as the subject might use different observers and/or the observer 
        would be linked to different types of subjects.

        \item \textit{Local: } Because the SoC creates this boundary between the subject and observer, local changes don't have 
        major implications on the rest of the system. The main implication might come when you switch an observer between different 
        implementations of a subject, such that the observer might also need to change it's behaviour accordingly. The only other 
        cases that might propagate greater changes through the system, are the reactions of the observer to the subject, but this is not 
        part of this design pattern anyways.
    \end{itemize}
    
    \paragraph{Prototype}
    We observe the Prototype pattern in the Figure class, as it allows the cloning of objects, through the clone method defiend in the interface.
     
    \begin{itemize}
        \item \textit{Separation of Concerns}: This is achieved as everything is encapsulated in the clone method.

        \item \textit{Single Responsability Principle:} This is achieved as the task of cloning is left entirely to the cloning method.

        \item \textit{Open-Close Principle: } The method cannot be modified, but can be overwritten in an extension.

        \item \textit{Composable: } Depending on the context, composabilty can be achieved as you can freely call method the clone method of parent classes.
        Further more, mutliple clone methods can be called allong each other on different objects. So this is also acheived. 

        \item \textit{Local: } Locallity of change is achieved as only the implementation know how to clone. Therefore changes to the clone method, apply only to the implementation.
    \end{itemize}


    \paragraph{Strategy}
    We observe this pattern between Figure (Interface), ConnectionFigure (Implementation) and Liner (Strategies). 
    As there are multiple ways to connect the endpoints of two figures, we have different strategies for this.

    \begin{itemize}
        \item \textit{Separation of Concerns}: This is achieved as we can move the different algorithmic implementations of
        connecting two figures, away from the Figure's implementations.

        \item \textit{Single Responsability Principle:} Each strategy implements only one way of connecting two figures, therefore
        it is focused on only that.

        \item \textit{Composable: } Composabilty is uphold, as we can freely apply different strategies on ConnectionFigure's 
        implementations.

        \item \textit{Local: } Locallity of change is uphold from the perspective of the strategies, as in the we don't have to
        the context. But if we change the context, it might be that we have to completly change the strategies. Though, this would still
        be only a local change.
    \end{itemize}  

    \subsection*{(b)}  
    The source code for the full project is in the corresponding folder. \\The main part of the plugin is under jhotdraw/src/main/java/org.jhotdraw7.samples.draw/org/jhotdraw/samples/draw/plugin/action\\
    The buttons are added inside jhotdraw/src/main/java/org.jhotdraw7.samples.draw/org/jhotdraw/samples/draw/DrawApplicationModel.java\\
    The last two buttons are flipping the figures. To test this, add two figures, group them and then flip them. For simplicity, the button icons were copied from the other ones.
    
    
\end{document}
